--C64 music 0.1
--Vendetta music replacement by Phil Spencer
c64music = {}

c64music.nextsong = Timer()
c64music.lastsong = nil
c64music.systemcheck = 0
c64music.on = 0
c64music.music = {
	title  = 'playmusic plugins/c64music/Yie_Ar_Kung_Fu.ogg',
	system = 'playmusic plugins/c64music/Advanced_Space_Battle_-_song_7.ogg',
	[1]    = {'playmusic plugins/c64music/Advanced_Space_Battle_-_song_6.ogg',539},
	[2]    = {'playmusic plugins/c64music/Advanced_Space_Battle_-_song_8.ogg',372},
	[3]    = {'playmusic plugins/c64music/Zarjaz.ogg',223},
	[4]    = {'playmusic plugins/c64music/Challenge_of_the_Gobots.ogg',223},
	[5]    = {'playmusic plugins/c64music/Last_Ninja_2_-_Central_Park.ogg',339},
	[6]    = {'playmusic plugins/c64music/Commando.ogg',248},
	[7]    = {'playmusic plugins/c64music/Ghosts_n_Goblins.ogg',231},
	[8]    = {'playmusic plugins/c64music/Advanced_Space_Battle_-_song_3.ogg',624},
	[9]    = {'playmusic plugins/c64music/Advanced_Space_Battle_-_song_5.ogg',473},
	[10]   = {'playmusic plugins/c64music/Yie_Ar_Kung_Fu.ogg',530},
	[11]   = {'playmusic plugins/c64music/Advanced_Space_Battle_-_song_7.ogg',405},
	[12]   = {'playmusic plugins/c64music/Advanced_Space_Battle_-_song_2.ogg',401},
}

function c64music.music_entergame()
   	c64music.systemcheck = 0
end

function c64music.music_random()
	if c64music.on == 0 then
		return
	end
	local song     = math.random(12)
	local duration = c64music.music[song][2] * 1000

   	if c64music.nextsong:IsActive() then
    	return
   	end
   	if song == c64music.lastsong then 
    	c64music.music_random()
      	return   
   	end
   	c64music.lastsong = song
   	if c64music.systemcheck == 0 then
    	gkinterface.GKProcessCommand(c64music.music['system'])
      	c64music.nextsong:SetTimeout(15000,c64music.music_random)
      	c64music.systemcheck = 1
      	return
   	end
   	c64music.nextsong:SetTimeout(duration,c64music.music_random)
   	gkinterface.GKProcessCommand(c64music.music[song][1])   
end

function c64music.music_spawnspace()
	if c64music.on == 0 then
		return
	end
	if c64music.systemcheck == 0 then
      	gkinterface.GKProcessCommand(c64music.music['system'])
      	c64music.nextsong:SetTimeout(15000,c64music.music_random)
      	c64music.systemcheck = 1
   	else
      	return
   	end
end

function c64music.theme()
	if c64music.on == 0 then
		return
	end
	gkinterface.GKProcessCommand(c64music.music['title'])	
end

--User Command functions 
function c64music.setDefault()
	gkini.WriteString("csmusic", "default", "c64music")
	c64music.defaults = "c64music"
end

function c64music.getDefault()
	c64music.defaults = gkini.ReadString("csmusic", "default", "")
	if c64music.defaults == "" then
		--No other CrazySpence music plugin has set default so set default now
		c64music.setDefault()
	end
end

function c64music.init()
	c64music.getDefault()
	if c64music.defaults == "c64music" then 
		c64music.on = 1 		
	end
end

function c64music.stop()
	c64music.on = 0
	c64music.nextsong:Kill()
	gkinterface.GKProcessCommand('stopmusic');
end

function c64music.start()
	c64music.on = 1
	c64music.music_random()
end

c64music.init()

--Event Handlers
RegisterEvent(c64music.music_entergame,"PLAYER_ENTERED_GAME")
RegisterEvent(c64music.music_random,"LEAVING_STATION")
RegisterEvent(c64music.music_spawnspace,"HUD_SHOW")
--Uncomment the line below if you want the Parsec theme to replace the opening theme
RegisterEvent(c64music.theme,"START")
--Command Handlers
RegisterUserCommand('c64musicdefault',c64music.setDefault)
RegisterUserCommand('c64musicstop',c64music.stop)
RegisterUserCommand('c64musicstart',c64music.start)